/////////////////////////////////////////////////////////////////////////////
// chemgrapgitm.h
// Define a item on a molecular graph
// Chemsuite Project
// Author: Ricardo Stefani
/////////////////////////////////////////////////////////////////////////////

#ifndef __CHEMGRAPHITM_H
#define __CHEMGRAPHITM_H

#include <qcanvas.h>
#include <qpainter.h>
#include <qstring.h>
#include <qpointarray.h>
#include "chemdefs.h"


class chemGraphItem: public QCanvasRectangle
{
private:

int start_x;
int start_y;
int end_x;
int end_y;

GraphItemType itmtype;
QPointArray pa;

protected:
   virtual void ProcessMol();
   void drawBond(QPainter& p, BondStyle style);
   void drawLabel(QPainter& p, QString text);
   void drawCiclePentane(QPainter& p);
   void drawCiclePentadiene(QPainter& p);
   void drawCicleHexane(QPainter& p);
   void drawAromatic(QPainter& p);

public:
chemGraphItem(QCanvas* canvas);
inline GraphItemType getType()
      { return itmtype; };

inline void setType(GraphItemType itm)
      {  itmtype = itm; };

~chemGraphItem();

void drawShape(QPainter& p);
void moveBy(double dx, double dy);
QPointArray points() const;
void setStart(QPoint ps);
void setEnd(QPoint ps);

// return the coords of each bond
inline QPointArray edgeAtomPoints()
     { return pa; };

};

#endif
